$(document).ready(function () {
  var config = {
      apiKey: "AIzaSyBQN9GToSw8bYWXkPrhueMV43ah9FP0eyY",
      authDomain: "accounts-abc79.firebaseapp.com",
      databaseURL: "https://accounts-abc79.firebaseio.com",
      storageBucket: ""
  };
  firebase.initializeApp(config);
        firebase.database().ref('users/' + getURLParameter("uid") + "/history").orderByChild("deliveryTime").on('value', function (snapshot) {
            var historyList = snapshot.val();
            var historyArray = [];
            for (var historyItem in historyList) {
            	historyArray.push(historyList[historyItem]);
            }
            historyArray.sort(function(a, b) {
		    a = new Date(a.deliveryTime);
		    b = new Date(b.deliveryTime);
		    return a>b ? -1 : a<b ? 1 : 0;
		});
            for (var i = 0; i < historyArray.length; i++) {
                if(!isInFuture(historyArray[i].deliveryTime) && !hasHiddenSegment(historyArray[i].segments)){
                    var item =  "<li class=\"list-group-item\">" +
                        "<h4 class=\"list-group-item-heading\">Message: " + historyArray[i].message + " <\/h4>"+
                        "<p class=\"list-group-item-text\">Delivery time:  " + formatDate(new Date(historyArray[i].deliveryTime)) + " <\/p>" +
                        "<\/li>";

                    $("#listview").append(item);
                }
            }
        });
});

function getURLParameter(name) {
  return decodeURIComponent((new RegExp('[?|&]' + name + '=' + '([^&;]+?)(&|#|;|$)').exec(location.search) || [null, ''])[1].replace(/\+/g, '%20')) || null;
}

var hiddenSegments = [];
function hasHiddenSegment(segments) {
    if(!segments || !hiddenSegments || hiddenSegments.length == 0){
        return false;
    }
    segments = JSON.parse(segments);
    for (var i = 0; i < segments.length; ++i) {
        var segment = segments[i];
        for (var j = 0; j < hiddenSegments.length; ++j) {
            if(segment == hiddenSegments[j]){
                return true;
            }
        }

    }
    return false;
}

function isInFuture(deliveryTime) {
    var now = new Date();
    if (deliveryTime > now) {
        return true;
    }
    return false;
}

function formatDate(date) {
    var hours = date.getHours();
    var minutes = date.getMinutes();
    var ampm = hours >= 12 ? 'pm' : 'am';
    hours = hours % 12;
    hours = hours ? hours : 12; // the hour '0' should be '12'
    minutes = minutes < 10 ? '0'+minutes : minutes;
    var strTime = hours + ':' + minutes + ' ' + ampm;
    return date.getMonth()+1 + "/" + date.getDate() + "/" + date.getFullYear() + "  " + strTime;
}
